#version 330 core

layout(location = 0) in vec3 vertexPosition;
layout(location = 1) in vec3 vertexNormal;
layout(location = 2) in vec2 vertexUV;
layout(location = 5) in vec2 boneIndex;
layout(location = 6) in vec2 boneWeight;

uniform mat4 mvpMatrix;
uniform mat4 modelMatrix;
uniform mat3 normalMatrix;
uniform mat4 DepthBiasMVP;

uniform mat4[30] boneMatrices;

out vec3 worldPosition;
out vec3 worldNormal;
out vec2 UV;
out vec4 ShadowCoord;

void main() {
	UV = vertexUV;
	vec4 interpolatedPos = vec4(0);
	interpolatedPos += (boneMatrices[int(boneIndex.x)] * vec4(vertexPosition, 1)) * boneWeight.x;
	interpolatedPos += (boneMatrices[int(boneIndex.y)] * vec4(vertexPosition, 1)) * boneWeight.y;
	worldPosition = (mvpMatrix * vec4(vertexPosition, 1)).xyz;
	worldNormal = normalMatrix * vertexNormal;
	gl_Position = mvpMatrix * interpolatedPos ;
	ShadowCoord = DepthBiasMVP * interpolatedPos,1;
}
